Expose bulk parameter for GetJobs in RAPI client
[ganeti-local] / Makefile.am
index 8359d6c..a99c84a 100644 (file)
@@ -14,6 +14,9 @@ empty :=
 space := $(empty) $(empty)
 comma := ,
 
+# Helper function to strip src/ and test/hs/ from a list
+strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
+
 # Use bash in order to be able to use pipefail
 SHELL=/bin/bash
 
@@ -37,6 +40,7 @@ SHELL_ENV_INIT = autotools/shell-env-init
 # Note: these are automake-specific variables, and must be named after
 # the directory + 'dir' suffix
 clientdir = $(pkgpythondir)/client
+cmdlibdir = $(pkgpythondir)/cmdlib
 hypervisordir = $(pkgpythondir)/hypervisor
 httpdir = $(pkgpythondir)/http
 masterddir = $(pkgpythondir)/masterd
@@ -61,10 +65,14 @@ HS_DIRS = \
        src/Ganeti/Block \
        src/Ganeti/Block/Drbd \
        src/Ganeti/Confd \
+       src/Ganeti/Curl \
        src/Ganeti/DataCollectors \
        src/Ganeti/HTools \
        src/Ganeti/HTools/Backend \
        src/Ganeti/HTools/Program \
+       src/Ganeti/Hypervisor \
+       src/Ganeti/Hypervisor/Xen \
+       src/Ganeti/Monitoring \
        src/Ganeti/Query \
        test/hs \
        test/hs/Test \
@@ -74,13 +82,19 @@ HS_DIRS = \
        test/hs/Test/Ganeti/Confd \
        test/hs/Test/Ganeti/HTools \
        test/hs/Test/Ganeti/HTools/Backend \
+       test/hs/Test/Ganeti/Hypervisor \
+       test/hs/Test/Ganeti/Hypervisor/Xen \
        test/hs/Test/Ganeti/Query
 
+# Haskell directories without the roots (src, test/hs)
+HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
+
 DIRS = \
        $(HS_DIRS) \
        autotools \
        daemons \
        devel \
+       devel/data \
        doc \
        doc/css \
        doc/examples \
@@ -89,9 +103,11 @@ DIRS = \
        test/data/htools \
        test/data/htools/rapi \
        test/hs/shelltests \
+       test/autotools \
        lib \
        lib/build \
        lib/client \
+       lib/cmdlib \
        lib/confd \
        lib/http \
        lib/hypervisor \
@@ -106,6 +122,7 @@ DIRS = \
        qa \
        test \
        test/data \
+       test/data/bdev-rbd \
        test/data/ovfdata \
        test/data/ovfdata/other \
        test/py \
@@ -113,15 +130,7 @@ DIRS = \
 
 ALL_APIDOC_HS_DIRS = \
        $(APIDOC_HS_DIR) \
-       $(APIDOC_HS_DIR)/Ganeti \
-       $(APIDOC_HS_DIR)/Ganeti/Block \
-       $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
-       $(APIDOC_HS_DIR)/Ganeti/Confd \
-       $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
-       $(APIDOC_HS_DIR)/Ganeti/HTools \
-       $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
-       $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
-       $(APIDOC_HS_DIR)/Ganeti/Query
+       $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
 
 BUILDTIME_DIR_AUTOCREATE = \
        scripts \
@@ -135,12 +144,14 @@ BUILDTIME_DIR_AUTOCREATE = \
 
 BUILDTIME_DIRS = \
        $(BUILDTIME_DIR_AUTOCREATE) \
-       doc/html
+       doc/html \
+       doc/man-html
 
 DIRCHECK_EXCLUDE = \
        $(BUILDTIME_DIRS) \
        ganeti-[0-9]*.[0-9]*.[0-9]* \
        doc/html/_* \
+       doc/man-html/_* \
        autom4te.cache
 
 # some helper vars
@@ -171,6 +182,10 @@ CLEANFILES = \
        $(SHELL_ENV_INIT) \
        daemons/daemon-util \
        daemons/ganeti-cleaner \
+       devel/squeeze-amd64.tar.gz \
+       devel/squeeze-amd64.conf \
+       $(mandocrst) \
+       doc/manpages-enabled.rst \
        $(BUILT_EXAMPLES) \
        doc/examples/bash_completion \
        doc/examples/bash_completion-debug \
@@ -178,6 +193,7 @@ CLEANFILES = \
        $(man_MANS) \
        $(manhtml) \
        tools/kvm-ifup \
+       tools/users-setup \
        tools/vcluster-setup \
        stamp-directories \
        stamp-srclinks \
@@ -185,6 +201,7 @@ CLEANFILES = \
        $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
        $(HS_BUILT_TEST_HELPERS) \
        src/ganeti-confd \
+       src/ganeti-mond \
        .hpc/*.mix src/*.tix test/hs/*.tix \
        doc/hs-lint.html
 
@@ -199,6 +216,10 @@ HS_GENERATED_FILES += $(HS_PROGS)
 if ENABLE_CONFD
 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
 endif
+
+if ENABLE_MOND
+HS_GENERATED_FILES += src/ganeti-mond
+endif
 endif
 
 built_base_sources = \
@@ -242,12 +263,12 @@ pkgpython_PYTHON = \
        lib/bdev.py \
        lib/bootstrap.py \
        lib/cli.py \
-       lib/cmdlib.py \
        lib/compat.py \
        lib/config.py \
        lib/constants.py \
        lib/daemon.py \
        lib/errors.py \
+       lib/hooksmaster.py \
        lib/ht.py \
        lib/jqueue.py \
        lib/jstore.py \
@@ -256,8 +277,8 @@ pkgpython_PYTHON = \
        lib/mcpu.py \
        lib/netutils.py \
        lib/objects.py \
-       lib/objectutils.py \
        lib/opcodes.py \
+       lib/outils.py \
        lib/ovf.py \
        lib/pathutils.py \
        lib/qlang.py \
@@ -287,6 +308,27 @@ client_PYTHON = \
        lib/client/gnt_os.py \
        lib/client/gnt_storage.py
 
+cmdlib_PYTHON = \
+       lib/cmdlib/__init__.py \
+       lib/cmdlib/backup.py \
+       lib/cmdlib/base.py \
+       lib/cmdlib/cluster.py \
+       lib/cmdlib/common.py \
+       lib/cmdlib/group.py \
+       lib/cmdlib/instance.py \
+       lib/cmdlib/instance_migration.py \
+       lib/cmdlib/instance_operation.py \
+       lib/cmdlib/instance_query.py \
+       lib/cmdlib/instance_storage.py \
+       lib/cmdlib/instance_utils.py \
+       lib/cmdlib/misc.py \
+       lib/cmdlib/network.py \
+       lib/cmdlib/node.py \
+       lib/cmdlib/operating_system.py \
+       lib/cmdlib/query.py \
+       lib/cmdlib/tags.py \
+       lib/cmdlib/test.py
+
 hypervisor_PYTHON = \
        lib/hypervisor/__init__.py \
        lib/hypervisor/hv_base.py \
@@ -336,6 +378,7 @@ server_PYTHON = \
 
 pytools_PYTHON = \
        lib/tools/__init__.py \
+       lib/tools/burnin.py \
        lib/tools/ensure_dirs.py \
        lib/tools/node_cleanup.py \
        lib/tools/node_daemon_setup.py \
@@ -370,10 +413,12 @@ docinput = \
        doc/design-2.5.rst \
        doc/design-2.6.rst \
        doc/design-2.7.rst \
+       doc/design-2.8.rst \
        doc/design-autorepair.rst \
        doc/design-bulk-create.rst \
        doc/design-chained-jobs.rst \
        doc/design-cpu-pinning.rst \
+       doc/design-device-uuid-name.rst \
        doc/design-draft.rst \
        doc/design-htools-2.3.rst \
        doc/design-http-server.rst \
@@ -389,12 +434,15 @@ docinput = \
        doc/design-partitioned.rst \
        doc/design-query-splitting.rst \
        doc/design-query2.rst \
-       doc/design-remote-commands.rst \
+       doc/design-reason-trail.rst \
        doc/design-resource-model.rst \
+       doc/design-restricted-commands.rst \
        doc/design-shared-storage.rst \
        doc/design-monitoring-agent.rst \
        doc/design-virtual-clusters.rst \
        doc/design-x509-ca.rst \
+       doc/design-hroller.rst \
+       doc/design-storagetypes.rst \
        doc/devnotes.rst \
        doc/glossary.rst \
        doc/hooks.rst \
@@ -403,6 +451,7 @@ docinput = \
        doc/install-quick.rst \
        doc/install.rst \
        doc/locking.rst \
+       doc/manpages-disabled.rst \
        doc/move-instance.rst \
        doc/news.rst \
        doc/ovfconverter.rst \
@@ -412,22 +461,29 @@ docinput = \
        doc/virtual-cluster.rst \
        doc/walkthrough.rst
 
+# Generates file names such as "doc/man-gnt-instance.rst"
+mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
+
 # Haskell programs to be installed in $PREFIX/bin
 HS_BIN_PROGS=src/htools
 
 # Haskell programs to be installed in the MYEXECLIB dir
+if ENABLE_MOND
 HS_MYEXECLIB_PROGS=src/mon-collector
+else
+HS_MYEXECLIB_PROGS=
+endif
 
-# Haskell programs to compiled but not installed automatically
-# Usually they have their own specific installation rules
+# Haskell programs to be compiled by "make really-all"
 HS_COMPILE_PROGS= \
+       src/ganeti-mond \
        src/hconfd \
        src/rpc-test
 
 # All Haskell non-test programs to be compiled but not automatically installed
 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
 
-HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
+HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
 
 HS_ALL_PROGS = \
@@ -474,10 +530,12 @@ HS_LIB_SRCS = \
        src/Ganeti/Confd/Types.hs \
        src/Ganeti/Confd/Utils.hs \
        src/Ganeti/Config.hs \
+       src/Ganeti/Curl/Multi.hs \
        src/Ganeti/Daemon.hs \
        src/Ganeti/DataCollectors/CLI.hs \
        src/Ganeti/DataCollectors/Drbd.hs \
        src/Ganeti/DataCollectors/Program.hs \
+       src/Ganeti/DataCollectors/Types.hs \
        src/Ganeti/Errors.hs \
        src/Ganeti/HTools/Backend/IAlloc.hs \
        src/Ganeti/HTools/Backend/Luxi.hs \
@@ -492,9 +550,11 @@ HS_LIB_SRCS = \
        src/Ganeti/HTools/Group.hs \
        src/Ganeti/HTools/Instance.hs \
        src/Ganeti/HTools/Loader.hs \
+       src/Ganeti/HTools/Nic.hs \
        src/Ganeti/HTools/Node.hs \
        src/Ganeti/HTools/PeerMap.hs \
        src/Ganeti/HTools/Program/Hail.hs \
+       src/Ganeti/HTools/Program/Harep.hs \
        src/Ganeti/HTools/Program/Hbal.hs \
        src/Ganeti/HTools/Program/Hcheck.hs \
        src/Ganeti/HTools/Program/Hinfo.hs \
@@ -503,22 +563,27 @@ HS_LIB_SRCS = \
        src/Ganeti/HTools/Program/Hroller.hs \
        src/Ganeti/HTools/Program/Main.hs \
        src/Ganeti/HTools/Types.hs \
+       src/Ganeti/Hypervisor/Xen/XmParser.hs \
+       src/Ganeti/Hypervisor/Xen/Types.hs \
        src/Ganeti/Hash.hs \
        src/Ganeti/JQueue.hs \
        src/Ganeti/JSON.hs \
        src/Ganeti/Jobs.hs \
        src/Ganeti/Logging.hs \
        src/Ganeti/Luxi.hs \
+       src/Ganeti/Monitoring/Server.hs \
        src/Ganeti/Network.hs \
        src/Ganeti/Objects.hs \
        src/Ganeti/OpCodes.hs \
        src/Ganeti/OpParams.hs \
        src/Ganeti/Path.hs \
        src/Ganeti/Query/Common.hs \
+       src/Ganeti/Query/Export.hs \
        src/Ganeti/Query/Filter.hs \
        src/Ganeti/Query/Group.hs \
        src/Ganeti/Query/Job.hs \
        src/Ganeti/Query/Language.hs \
+       src/Ganeti/Query/Network.hs \
        src/Ganeti/Query/Node.hs \
        src/Ganeti/Query/Query.hs \
        src/Ganeti/Query/Server.hs \
@@ -551,6 +616,7 @@ HS_TEST_SRCS = \
        test/hs/Test/Ganeti/HTools/Node.hs \
        test/hs/Test/Ganeti/HTools/PeerMap.hs \
        test/hs/Test/Ganeti/HTools/Types.hs \
+       test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
        test/hs/Test/Ganeti/JSON.hs \
        test/hs/Test/Ganeti/Jobs.hs \
        test/hs/Test/Ganeti/JQueue.hs \
@@ -560,8 +626,10 @@ HS_TEST_SRCS = \
        test/hs/Test/Ganeti/OpCodes.hs \
        test/hs/Test/Ganeti/Query/Filter.hs \
        test/hs/Test/Ganeti/Query/Language.hs \
+       test/hs/Test/Ganeti/Query/Network.hs \
        test/hs/Test/Ganeti/Query/Query.hs \
        test/hs/Test/Ganeti/Rpc.hs \
+       test/hs/Test/Ganeti/Runtime.hs \
        test/hs/Test/Ganeti/Ssconf.hs \
        test/hs/Test/Ganeti/THH.hs \
        test/hs/Test/Ganeti/TestCommon.hs \
@@ -575,35 +643,61 @@ HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
 HS_BUILT_SRCS = \
        test/hs/Test/Ganeti/TestImports.hs \
        src/Ganeti/Constants.hs \
+       src/Ganeti/Curl/Internal.hs \
        src/Ganeti/Version.hs
-HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
+HS_BUILT_SRCS_IN = \
+       $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
+       src/Ganeti/Curl/Internal.hsc
+
+HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
 
 $(RUN_IN_TEMPDIR): | stamp-directories
 
+doc/html/index.html: ENABLE_MANPAGES =
+doc/man-html/index.html: ENABLE_MANPAGES = 1
+doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
+
 # Note: we use here an order-only prerequisite, as the contents of
 # _autoconf.py are not actually influencing the html build output: it
 # has to exist in order for the sphinx module to be loaded
 # successfully, but we certainly don't want the docs to be rebuilt if
 # it changes
-doc/html/index.html: $(docinput) doc/conf.py configure.ac \
-       $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
+doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
+       configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
        lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
-       doc/css/style.css \
+       doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
        | $(BUILT_PYTHON_SOURCES)
        @test -n "$(SPHINX)" || \
            { echo 'sphinx-build' not found during configure; exit 1; }
-       @mkdir_p@ $(dir $@)
-       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
+if !MANPAGES_IN_DOC
+       if test -n '$(ENABLE_MANPAGES)'; then \
+         echo 'Man pages in documentation were disabled at configure time' >&2; \
+         exit 1; \
+       fi
+endif
+## Sphinx provides little control over what content should be included. Some
+## mechanisms exist, but they all have drawbacks or actual issues. Since we
+## build two different versions of the documentation--once without man pages and
+## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
+## us with this, but requires running in a temporary directory. It moves the
+## correct files into place depending on environment variables.
+       dir=$(dir $@) && \
+       @mkdir_p@ $$dir && \
+       PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
+       $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
            -d . \
            -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
            -D release="$(PACKAGE_VERSION)" \
            -D graphviz_dot="$(DOT)" \
-           $(abs_top_builddir)/doc $(CURDIR)/doc/html
-       rm -f doc/html/.buildinfo doc/html/objects.inv
+           -D enable_manpages="$(ENABLE_MANPAGES)" \
+           doc $(CURDIR)/$$dir && \
+       rm -f $$dir/.buildinfo $$dir/objects.inv
        touch $@
 
 doc/html: doc/html/index.html
 
+doc/man-html: doc/man-html/index.html
+
 doc/install-quick.rst: INSTALL
 doc/news.rst: NEWS
 doc/upgrade.rst: UPGRADE
@@ -616,6 +710,34 @@ doc/install-quick.rst doc/news.rst doc/upgrade.rst:
          cat $<; \
        } > $@
 
+doc/manpages-enabled.rst: Makefile | $(built_base_sources)
+       { echo '.. This file is automatically generated, do not edit!'; \
+         echo ''; \
+         echo 'Man pages'; \
+         echo '========='; \
+         echo; \
+         echo '.. toctree::'; \
+         echo '   :maxdepth: 1'; \
+         echo; \
+         for i in $(notdir $(mandocrst)); do \
+           echo "   $$i"; \
+         done | LC_ALL=C sort; \
+       } > $@
+
+doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
+if MANPAGES_IN_DOC
+       { echo '.. This file is automatically updated at build time from $<.'; \
+         echo '.. Do not edit.'; \
+         echo; \
+         echo "$*"; \
+         echo '=========================================='; \
+         tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
+       } > $@
+else
+       echo 'Man pages in documentation were disabled at configure time' >&2; \
+       exit 1;
+endif
+
 # Things to build but not to install (add it to EXTRA_DIST if it should be
 # distributed)
 noinst_DATA = \
@@ -625,6 +747,10 @@ noinst_DATA = \
        doc/examples/bash_completion-debug \
        $(manhtml)
 
+if MANPAGES_IN_DOC
+noinst_DATA += doc/man-html
+endif
+
 gnt_scripts = \
        scripts/gnt-backup \
        scripts/gnt-cluster \
@@ -646,6 +772,7 @@ PYTHON_BOOTSTRAP_SBIN = \
 
 PYTHON_BOOTSTRAP = \
        $(PYTHON_BOOTSTRAP_SBIN) \
+       tools/burnin \
        tools/ensure-dirs \
        tools/node-cleanup \
        tools/node-daemon-setup \
@@ -681,7 +808,7 @@ install-exec-hook:
        done
 endif
 
-$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
+$(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
        @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
          echo "Error: cannot run unittests without the development" \
               " libraries (see devnotes.rst)" 1>&2; \
@@ -690,7 +817,7 @@ $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
        @rm -f $(notdir $@).tix
        $(GHC) --make \
          $(HFLAGS) \
-         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
+         $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
          -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
          $(HEXTRA) $(HEXTRA_INT) $@
        @touch "$@"
@@ -705,7 +832,7 @@ test/hs/hpc-htools: HEXTRA_INT=-fhpc
 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
 
 # test dependency
-test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
+test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
 
 # rules for building profiling-enabled versions of the haskell
 # programs: hs-prof does the full two-step build, whereas
@@ -743,8 +870,11 @@ src/ganeti-confd: src/hconfd
 nodist_sbin_SCRIPTS += src/ganeti-confd
 endif
 
+if ENABLE_MOND
+nodist_sbin_SCRIPTS += src/ganeti-mond
+endif
+
 python_scripts = \
-       tools/burnin \
        tools/cfgshell \
        tools/cfgupgrade \
        tools/cfgupgrade12 \
@@ -758,6 +888,7 @@ python_scripts = \
 
 dist_tools_SCRIPTS = \
        $(python_scripts) \
+       tools/burnin \
        tools/kvm-console-wrapper \
        tools/master-ip-setup \
        tools/xen-console-wrapper
@@ -767,6 +898,7 @@ nodist_tools_python_scripts = \
 
 nodist_tools_SCRIPTS = \
        $(nodist_tools_python_scripts) \
+       tools/users-setup \
        tools/vcluster-setup
 
 pkglib_python_scripts = \
@@ -806,6 +938,7 @@ EXTRA_DIST = \
        autotools/convert-constants \
        autotools/docpp \
        autotools/gen-py-coverage \
+       autotools/sphinx-wrapper \
        autotools/testrunner \
        autotools/wrong-hardcoded-paths \
        $(RUN_IN_TEMPDIR) \
@@ -815,6 +948,7 @@ EXTRA_DIST = \
        devel/upload \
        devel/webserver \
        tools/kvm-ifup.in \
+       tools/users-setup.in \
        tools/vcluster-setup.in \
        $(docinput) \
        doc/html \
@@ -847,6 +981,7 @@ man_MANS = \
        man/ganeti-confd.8 \
        man/ganeti-listrunner.8 \
        man/ganeti-masterd.8 \
+       man/ganeti-mond.8 \
        man/ganeti-noded.8 \
        man/ganeti-os-interface.7 \
        man/ganeti-extstorage-interface.7 \
@@ -864,6 +999,7 @@ man_MANS = \
        man/gnt-os.8 \
        man/gnt-storage.8 \
        man/hail.1 \
+       man/harep.1 \
        man/hbal.1 \
        man/hcheck.1 \
        man/hinfo.1 \
@@ -873,7 +1009,10 @@ man_MANS = \
        man/htools.1 \
        man/mon-collector.7
 
-manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
+# Remove extensions from all filenames in man_MANS
+mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
+
+manrst = $(patsubst %,%.rst,$(mannoext))
 manhtml = $(patsubst %.rst,%.html,$(manrst))
 mangen = $(patsubst %.rst,%.gen,$(manrst))
 maninput = \
@@ -882,28 +1021,40 @@ maninput = \
        $(mangen)
 
 TEST_FILES = \
+       test/autotools/autotools-check-news.test \
        test/data/htools/clean-nonzero-score.data \
        test/data/htools/common-suffix.data \
        test/data/htools/empty-cluster.data \
        test/data/htools/hail-alloc-drbd.json \
+       test/data/htools/hail-alloc-invalid-network.json \
+       test/data/htools/hail-alloc-invalid-twodisks.json \
+       test/data/htools/hail-alloc-restricted-network.json \
+       test/data/htools/hail-alloc-twodisks.json \
        test/data/htools/hail-change-group.json \
        test/data/htools/hail-invalid-reloc.json \
        test/data/htools/hail-node-evac.json \
        test/data/htools/hail-reloc-drbd.json \
        test/data/htools/hbal-excl-tags.data \
        test/data/htools/hbal-split-insts.data \
+       test/data/htools/hspace-tiered-dualspec.data \
+       test/data/htools/hspace-tiered-ipolicy.data \
+       test/data/htools/hspace-tiered-resourcetypes.data \
+       test/data/htools/hspace-tiered.data \
        test/data/htools/invalid-node.data \
        test/data/htools/missing-resources.data \
+       test/data/htools/multiple-master.data \
        test/data/htools/n1-failure.data \
        test/data/htools/rapi/groups.json \
        test/data/htools/rapi/info.json \
        test/data/htools/rapi/instances.json \
        test/data/htools/rapi/nodes.json \
+       test/data/htools/unique-reboot-order.data \
        test/hs/shelltests/htools-balancing.test \
        test/hs/shelltests/htools-basic.test \
        test/hs/shelltests/htools-dynutil.test \
        test/hs/shelltests/htools-excl.test \
        test/hs/shelltests/htools-hail.test \
+       test/hs/shelltests/htools-hroller.test \
        test/hs/shelltests/htools-hspace.test \
        test/hs/shelltests/htools-invalid.test \
        test/hs/shelltests/htools-multi-group.test \
@@ -917,8 +1068,22 @@ TEST_FILES = \
        test/data/bdev-drbd-disk.txt \
        test/data/bdev-drbd-net-ip4.txt \
        test/data/bdev-drbd-net-ip6.txt \
+       test/data/bdev-rbd/json_output_empty.txt \
+       test/data/bdev-rbd/json_output_extra_matches.txt \
+       test/data/bdev-rbd/json_output_no_matches.txt \
+       test/data/bdev-rbd/json_output_ok.txt \
+       test/data/bdev-rbd/plain_output_new_extra_matches.txt \
+       test/data/bdev-rbd/plain_output_new_no_matches.txt \
+       test/data/bdev-rbd/plain_output_new_ok.txt \
+       test/data/bdev-rbd/plain_output_old_empty.txt \
+       test/data/bdev-rbd/plain_output_old_extra_matches.txt \
+       test/data/bdev-rbd/plain_output_old_no_matches.txt \
+       test/data/bdev-rbd/plain_output_old_ok.txt \
+       test/data/bdev-rbd/output_invalid.txt \
        test/data/cert1.pem \
        test/data/cert2.pem \
+       test/data/cluster_config_2.7.json \
+       test/data/cluster_config_downgraded_2.7.json \
        test/data/instance-minor-pairing.txt \
        test/data/ip-addr-show-dummy0.txt \
        test/data/ip-addr-show-lo-ipv4.txt \
@@ -930,7 +1095,11 @@ TEST_FILES = \
        test/data/kvm_0.12.5_help.txt \
        test/data/kvm_0.15.90_help.txt \
        test/data/kvm_0.9.1_help.txt \
+       test/data/kvm_0.9.1_help_boot_test.txt \
        test/data/kvm_1.0_help.txt \
+       test/data/kvm_1.1.2_help.txt \
+       test/data/NEWS_OK.txt \
+       test/data/NEWS_previous_unreleased.txt \
        test/data/ovfdata/compr_disk.vmdk.gz \
        test/data/ovfdata/config.ini \
        test/data/ovfdata/corrupted_resources.ovf \
@@ -962,16 +1131,23 @@ TEST_FILES = \
        test/data/proc_drbd83_sync.txt \
        test/data/proc_drbd83_sync_want.txt \
        test/data/proc_drbd83_sync_krnl2.6.39.txt \
+       test/data/qa-minimal-nodes-instances-only.json \
        test/data/sys_drbd_usermode_helper.txt \
        test/data/vgreduce-removemissing-2.02.02.txt \
        test/data/vgreduce-removemissing-2.02.66-fail.txt \
        test/data/vgreduce-removemissing-2.02.66-ok.txt \
        test/data/vgs-missing-pvs-2.02.02.txt \
        test/data/vgs-missing-pvs-2.02.66.txt \
+       test/data/xen-xm-info-4.0.1.txt \
+       test/data/xen-xm-list-4.0.1-dom0-only.txt \
+       test/data/xen-xm-list-4.0.1-four-instances.txt \
+       test/data/xen-xm-list-long-4.0.1.txt \
+       test/data/xen-xm-uptime-4.0.1.txt \
        test/py/ganeti-cli.test \
        test/py/gnt-cli.test \
        test/py/import-export_unittest-helper
 
+
 python_tests = \
        doc/examples/rapi_testutils.py \
        test/py/cfgupgrade_unittest.py \
@@ -1010,8 +1186,8 @@ python_tests = \
        test/py/ganeti.mcpu_unittest.py \
        test/py/ganeti.netutils_unittest.py \
        test/py/ganeti.objects_unittest.py \
-       test/py/ganeti.objectutils_unittest.py \
        test/py/ganeti.opcodes_unittest.py \
+       test/py/ganeti.outils_unittest.py \
        test/py/ganeti.ovf_unittest.py \
        test/py/ganeti.qlang_unittest.py \
        test/py/ganeti.query_unittest.py \
@@ -1027,6 +1203,7 @@ python_tests = \
        test/py/ganeti.ssconf_unittest.py \
        test/py/ganeti.ssh_unittest.py \
        test/py/ganeti.storage_unittest.py \
+       test/py/ganeti.tools.burnin_unittest.py \
        test/py/ganeti.tools.ensure_dirs_unittest.py \
        test/py/ganeti.tools.node_daemon_setup_unittest.py \
        test/py/ganeti.tools.prepare_node_join_unittest.py \
@@ -1060,8 +1237,11 @@ dist_TESTS = \
        test/py/ganeti-cleaner_unittest.bash \
        test/py/import-export_unittest.bash \
        test/py/cli-test.bash \
-       test/py/bash_completion.bash \
-       $(python_tests)
+       test/py/bash_completion.bash
+
+if !PY_NODEV
+       dist_TESTS += $(python_tests)
+endif
 
 nodist_TESTS =
 check_SCRIPTS =
@@ -1094,9 +1274,9 @@ all_python_code = \
        $(pkglib_python_scripts) \
        $(nodist_pkglib_python_scripts) \
        $(nodist_tools_python_scripts) \
-       $(python_tests) \
        $(pkgpython_PYTHON) \
        $(client_PYTHON) \
+       $(cmdlib_PYTHON) \
        $(hypervisor_PYTHON) \
        $(rapi_PYTHON) \
        $(server_PYTHON) \
@@ -1110,6 +1290,10 @@ all_python_code = \
        $(noinst_PYTHON) \
        $(qa_scripts)
 
+if !PY_NODEV
+       all_python_code += $(python_tests)
+endif
+
 srclink_files = \
        man/footer.rst \
        test/py/check-cert-expired_unittest.bash \
@@ -1169,6 +1353,10 @@ tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
 
+tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
+       sed -f $(REPLACE_VARS_SED) < $< > $@
+       chmod +x $@
+
 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
@@ -1208,7 +1396,7 @@ man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
-       set -o pipefail ; \
+       set -o pipefail -e; \
        trap 'echo auto-removing $@; rm $@' EXIT; \
        $(PANDOC) -s -f rst -t man $< man/footer.rst | \
          sed -e 's/\\@/@/g' > $@; \
@@ -1268,6 +1456,9 @@ src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
          PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
        } > $@
 
+src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
+       hsc2hs -o $@ $<
+
 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
        $(built_base_sources)
        set -e; \
@@ -1310,6 +1501,7 @@ lib/_autoconf.py: Makefile | stamp-directories
          echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
          echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
          echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
+         echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
          echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
          echo "XEN_INITRD = '$(XEN_INITRD)'"; \
          echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
@@ -1341,6 +1533,8 @@ lib/_autoconf.py: Makefile | stamp-directories
          echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
          echo "NODED_USER = '$(NODED_USER)'"; \
          echo "NODED_GROUP = '$(NODED_GROUP)'"; \
+         echo "MOND_USER = '$(MOND_USER)'"; \
+         echo "MOND_GROUP = '$(MOND_GROUP)'"; \
          echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
          echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
          echo "HTOOLS = True"; \
@@ -1348,7 +1542,14 @@ lib/_autoconf.py: Makefile | stamp-directories
          echo "XEN_CMD = '$(XEN_CMD)'"; \
          echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
          echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
-         echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
+         echo "ENABLE_MOND = $(ENABLE_MOND)"; \
+## Write dictionary with man page name as the key and the section number as the
+## value
+         echo "MAN_PAGES = {"; \
+         for i in $(notdir $(man_MANS)); do \
+           echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
+         done; \
+         echo "}"; \
        } > $@
 
 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
@@ -1388,35 +1589,41 @@ $(SHELL_ENV_INIT): Makefile stamp-directories
          echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
        } > $@
 
+## Writes sed script to replace placeholders with build-time values. The
+## additional quotes after the first @ sign are necessary to stop configure
+## from replacing those values as well.
 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
        set -e; \
-       { echo 's#@PREFIX@#$(prefix)#g'; \
-         echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
-         echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
-         echo 's#@BINDIR@#$(bindir)#g'; \
-         echo 's#@SBINDIR@#$(sbindir)#g'; \
-         echo 's#@LIBDIR@#$(libdir)#g'; \
-         echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
-         echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
-         echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
-         echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
-         echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
-         echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
-         echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
-         echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
-         echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
-         echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
-         echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
-         echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
-         echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
-         echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
-         echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
-         echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
-         echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
-         echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
-         echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
-         echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
-         echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
+       { echo 's#@''PREFIX@#$(prefix)#g'; \
+         echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
+         echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
+         echo 's#@''BINDIR@#$(bindir)#g'; \
+         echo 's#@''SBINDIR@#$(sbindir)#g'; \
+         echo 's#@''LIBDIR@#$(libdir)#g'; \
+         echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
+         echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
+         echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
+         echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
+         echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
+         echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
+         echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
+         echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
+         echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
+         echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
+         echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
+         echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
+         echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
+         echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
+         echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
+         echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
+         echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
+         echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
+         echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
+         echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
+         echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
+         echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
+         echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
+         echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
          echo; \
          echo '/^@SHELL_ENV_INIT@$$/ {'; \
          echo '  r $(SHELL_ENV_INIT)'; \
@@ -1428,6 +1635,7 @@ $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
 daemons/ganeti-watcher: MODULE = ganeti.watcher
 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
+tools/burnin: MODULE = ganeti.tools.burnin
 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
@@ -1517,30 +1725,32 @@ check-local: check-dirs $(GENERATED_FILES)
        $(CHECK_PYTHON_CODE) $(check_python_code)
        PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
        $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
-       $(CHECK_NEWS) < $(top_srcdir)/NEWS
+       RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
-       @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
        error= ; \
-       if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
-         echo "Incorrect version in README, expected $$expver" >&2; \
-         error=1; \
-       fi; \
-       for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
-           doc/security.rst; do \
-         if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
-           "Documents Ganeti version $$expver"; then \
-           echo "Incorrect version in $$file, expected $$expver" >&2; \
+       if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
+         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
+         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
+           echo "Incorrect version in README, expected $$expver" >&2; \
+           error=1; \
+         fi; \
+         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
+             doc/security.rst; do \
+           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
+             "Documents Ganeti version $$expver"; then \
+             echo "Incorrect version in $$file, expected $$expver" >&2; \
+             error=1; \
+           fi; \
+         done; \
+         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
+           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
+           error=1; \
+         fi; \
+         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
+           ".. Last updated for Ganeti $$expver"; then \
+           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
            error=1; \
          fi; \
-       done; \
-       if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
-         echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
-         error=1; \
-       fi; \
-       if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
-         ".. Last updated for Ganeti $$expver"; then \
-         echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
-         error=1; \
        fi; \
        for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
          if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
@@ -1615,6 +1825,7 @@ HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
 .PHONY: hlint
 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
        @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
+       @rm -f doc/hs-lint.html
        if tty -s; then C="-c"; else C=""; fi; \
        $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
          --ignore "Use first" \
@@ -1623,6 +1834,9 @@ hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
          --ignore "Reduce duplication" \
          --hint src/lint-hints \
          $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
+       @if [ ! -f doc/hs-lint.html ]; then \
+         echo "All good" > doc/hs-lint.html; \
+       fi
 
 # a dist hook rule for updating the vcs-version file; this is
 # hardcoded due to where it needs to build the file...
@@ -1654,14 +1868,12 @@ distcheck-hook:
          echo "Found empty files or directories in final archive." 1>&2; \
          exit 1; \
        fi
-       if test -n "$(BUILD_RELEASE)" && \
-          grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
-          echo "Found unreleased version in NEWS." >&2; \
-          exit 1; \
+       if test -e $(top_distdir)/doc/man-html; then \
+         echo "Found documentation including man pages in final archive" >&2; \
+         exit 1; \
        fi
 
-# When building a release, stricter checks should be used
-distcheck-release dist-release: export BUILD_RELEASE = 1
+# Backwards compatible distcheck-release target
 distcheck-release: distcheck
 
 distrebuildcheck: dist
@@ -1705,7 +1917,9 @@ py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
          --output $(CURDIR)/$(APIDOC_PY_DIR)
 
 .PHONY: hs-apidoc
-hs-apidoc: $(HS_BUILT_SRCS)
+hs-apidoc: $(APIDOC_HS_DIR)/index.html
+
+$(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
        @test -n "$(HSCOLOUR)" || \
            { echo 'HsColour' not found during configure; exit 1; }
        @test -n "$(HADDOCK)" || \
@@ -1713,40 +1927,36 @@ hs-apidoc: $(HS_BUILT_SRCS)
        rm -rf $(APIDOC_HS_DIR)/*
        for i in $(ALL_APIDOC_HS_DIRS); do \
          @mkdir_p@ $$i; \
+         $(HSCOLOUR) -print-css > $$i/hscolour.css; \
        done
-       $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
-       $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
-       $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
        set -e ; \
-       cd src; \
-       if [ "$(HS_NOCURL)" ]; \
-       then OPTGHC="--optghc=$(HS_NOCURL)"; \
-       else OPTGHC=""; \
-       fi; \
+       export LC_ALL=en_US.UTF-8; \
+       OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
        if [ "$(HS_PARALLEL3)" ]; \
        then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
        fi; \
        if [ "$(HS_REGEX_PCRE)" ]; \
        then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
        fi; \
-       RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
-       for file in $$RELSRCS; do \
-         hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
-         $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
+       for file in $(HS_LIBTESTBUILT_SRCS); do \
+         f_nosrc=$${file##src/}; \
+         f_notst=$${f_nosrc##test/hs/}; \
+         f_html=$${f_notst%%.hs}.html; \
+         $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
        done ; \
-       $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
-         -t ganeti -p haddock-prologue \
+       $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
+         -t ganeti -p src/haddock-prologue \
          --source-module="%{MODULE/.//}.html" \
          --source-entity="%{MODULE/.//}.html#%{NAME}" \
          $$OPTGHC \
-         $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
+         $(HS_LIBTESTBUILT_SRCS)
 
 .PHONY: TAGS
 TAGS: $(GENERATED_FILES)
        rm -f TAGS
        $(GHC) -e ":etags" -v0 \
          $(filter-out -O -Werror,$(HFLAGS)) \
-         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
+         $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
          $(HS_LIBTEST_SRCS)
        find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
          -path './daemons/ganeti-*' -o -path './tools/*' -o \
@@ -1754,12 +1964,17 @@ TAGS: $(GENERATED_FILES)
          etags -l python -a -
 
 .PHONY: coverage
+
+COVERAGE_TESTS=
 if WANT_HTOOLS
-coverage: py-coverage hs-coverage
-else
-coverage: py-coverage
+COVERAGE_TESTS += hs-coverage
+endif
+if !PY_NODEV
+COVERAGE_TESTS += py-coverage
 endif
 
+coverage: $(COVERAGE_TESTS)
+
 .PHONY: py-coverage
 py-coverage: $(GENERATED_FILES) $(python_tests)
        @test -n "$(PYCOVERAGE)" || \
@@ -1800,7 +2015,12 @@ live-test: all
          --srcdir=.. $(HPCEXCL) ; \
        hpc report --srcdir=.. live-test $(HPCEXCL)
 
-commit-check: distcheck lint apidoc
+commit-check: autotools-check distcheck lint apidoc
+
+autotools-check:
+       TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
+  $(abs_top_srcdir)/test/autotools/*-*.test \
+  -- --hide-successes
 
 .PHONY: gitignore-check
 gitignore-check: